<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>NHttpEntityWrapper xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../apidocs/org/apache/http/nio/entity/NHttpEntityWrapper.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  
<a class="jxr_linenumber" name="28" href="#28">28</a>  <strong class="jxr_keyword">package</strong> org.apache.http.nio.entity;
<a class="jxr_linenumber" name="29" href="#29">29</a>  
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> java.io.IOException;
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> java.io.InputStream;
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> java.io.OutputStream;
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> java.nio.ByteBuffer;
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> java.nio.channels.Channels;
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> java.nio.channels.ReadableByteChannel;
<a class="jxr_linenumber" name="36" href="#36">36</a>  
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpEntity;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> org.apache.http.annotation.NotThreadSafe;
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> org.apache.http.entity.HttpEntityWrapper;
<a class="jxr_linenumber" name="40" href="#40">40</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.ContentEncoder;
<a class="jxr_linenumber" name="41" href="#41">41</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.IOControl;
<a class="jxr_linenumber" name="42" href="#42">42</a>  
<a class="jxr_linenumber" name="43" href="#43">43</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="44" href="#44">44</a>  <em class="jxr_javadoccomment"> * {@link ProducingNHttpEntity} compatibility adaptor for blocking HTTP</em>
<a class="jxr_linenumber" name="45" href="#45">45</a>  <em class="jxr_javadoccomment"> * entities.</em>
<a class="jxr_linenumber" name="46" href="#46">46</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="47" href="#47">47</a>  <em class="jxr_javadoccomment"> * @since 4.0</em>
<a class="jxr_linenumber" name="48" href="#48">48</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="49" href="#49">49</a>  <em class="jxr_javadoccomment"> * @deprecated (4.2) use {@link EntityAsyncContentProducer}</em>
<a class="jxr_linenumber" name="50" href="#50">50</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="51" href="#51">51</a>  @NotThreadSafe
<a class="jxr_linenumber" name="52" href="#52">52</a>  @Deprecated
<a class="jxr_linenumber" name="53" href="#53">53</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../org/apache/http/nio/entity/NHttpEntityWrapper.html">NHttpEntityWrapper</a>
<a class="jxr_linenumber" name="54" href="#54">54</a>      <strong class="jxr_keyword">extends</strong> HttpEntityWrapper <strong class="jxr_keyword">implements</strong> <a href="../../../../../org/apache/http/nio/entity/ProducingNHttpEntity.html">ProducingNHttpEntity</a> {
<a class="jxr_linenumber" name="55" href="#55">55</a>  
<a class="jxr_linenumber" name="56" href="#56">56</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> ReadableByteChannel channel;
<a class="jxr_linenumber" name="57" href="#57">57</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> ByteBuffer buffer;
<a class="jxr_linenumber" name="58" href="#58">58</a>  
<a class="jxr_linenumber" name="59" href="#59">59</a>      <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/nio/entity/NHttpEntityWrapper.html">NHttpEntityWrapper</a>(<strong class="jxr_keyword">final</strong> HttpEntity httpEntity) <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="60" href="#60">60</a>          <strong class="jxr_keyword">super</strong>(httpEntity);
<a class="jxr_linenumber" name="61" href="#61">61</a>          <strong class="jxr_keyword">this</strong>.channel = Channels.newChannel(httpEntity.getContent());
<a class="jxr_linenumber" name="62" href="#62">62</a>          <strong class="jxr_keyword">this</strong>.buffer = ByteBuffer.allocate(4096);
<a class="jxr_linenumber" name="63" href="#63">63</a>      }
<a class="jxr_linenumber" name="64" href="#64">64</a>  
<a class="jxr_linenumber" name="65" href="#65">65</a>      <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="66" href="#66">66</a>  <em class="jxr_javadoccomment">     * This method throws {@link UnsupportedOperationException}.</em>
<a class="jxr_linenumber" name="67" href="#67">67</a>  <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="68" href="#68">68</a>      @Override
<a class="jxr_linenumber" name="69" href="#69">69</a>      <strong class="jxr_keyword">public</strong> InputStream getContent() <strong class="jxr_keyword">throws</strong> IOException, UnsupportedOperationException {
<a class="jxr_linenumber" name="70" href="#70">70</a>          <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> UnsupportedOperationException(<span class="jxr_string">"Does not support blocking methods"</span>);
<a class="jxr_linenumber" name="71" href="#71">71</a>      }
<a class="jxr_linenumber" name="72" href="#72">72</a>  
<a class="jxr_linenumber" name="73" href="#73">73</a>      @Override
<a class="jxr_linenumber" name="74" href="#74">74</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> isStreaming() {
<a class="jxr_linenumber" name="75" href="#75">75</a>          <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="76" href="#76">76</a>      }
<a class="jxr_linenumber" name="77" href="#77">77</a>  
<a class="jxr_linenumber" name="78" href="#78">78</a>      <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="79" href="#79">79</a>  <em class="jxr_javadoccomment">     * This method throws {@link UnsupportedOperationException}.</em>
<a class="jxr_linenumber" name="80" href="#80">80</a>  <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="81" href="#81">81</a>      @Override
<a class="jxr_linenumber" name="82" href="#82">82</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> writeTo(OutputStream out) <strong class="jxr_keyword">throws</strong> IOException, UnsupportedOperationException {
<a class="jxr_linenumber" name="83" href="#83">83</a>          <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> UnsupportedOperationException(<span class="jxr_string">"Does not support blocking methods"</span>);
<a class="jxr_linenumber" name="84" href="#84">84</a>      }
<a class="jxr_linenumber" name="85" href="#85">85</a>  
<a class="jxr_linenumber" name="86" href="#86">86</a>      <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="87" href="#87">87</a>  <em class="jxr_javadoccomment">     * This method is equivalent to the {@link #finish()} method.</em>
<a class="jxr_linenumber" name="88" href="#88">88</a>  <em class="jxr_javadoccomment">     * &lt;br/&gt;</em>
<a class="jxr_linenumber" name="89" href="#89">89</a>  <em class="jxr_javadoccomment">     * TODO: The name of this method is misnomer. It will be renamed to</em>
<a class="jxr_linenumber" name="90" href="#90">90</a>  <em class="jxr_javadoccomment">     * #finish() in the next major release.</em>
<a class="jxr_linenumber" name="91" href="#91">91</a>  <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="92" href="#92">92</a>      @Override
<a class="jxr_linenumber" name="93" href="#93">93</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> consumeContent() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="94" href="#94">94</a>          finish();
<a class="jxr_linenumber" name="95" href="#95">95</a>      }
<a class="jxr_linenumber" name="96" href="#96">96</a>  
<a class="jxr_linenumber" name="97" href="#97">97</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> produceContent(
<a class="jxr_linenumber" name="98" href="#98">98</a>              <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/ContentEncoder.html">ContentEncoder</a> encoder,
<a class="jxr_linenumber" name="99" href="#99">99</a>              <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/IOControl.html">IOControl</a> ioctrl) <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="100" href="#100">100</a>         <strong class="jxr_keyword">int</strong> i = <strong class="jxr_keyword">this</strong>.channel.read(<strong class="jxr_keyword">this</strong>.buffer);
<a class="jxr_linenumber" name="101" href="#101">101</a>         <strong class="jxr_keyword">this</strong>.buffer.flip();
<a class="jxr_linenumber" name="102" href="#102">102</a>         encoder.write(<strong class="jxr_keyword">this</strong>.buffer);
<a class="jxr_linenumber" name="103" href="#103">103</a>         <strong class="jxr_keyword">boolean</strong> buffering = <strong class="jxr_keyword">this</strong>.buffer.hasRemaining();
<a class="jxr_linenumber" name="104" href="#104">104</a>         <strong class="jxr_keyword">this</strong>.buffer.compact();
<a class="jxr_linenumber" name="105" href="#105">105</a>         <strong class="jxr_keyword">if</strong> (i == -1 &amp;&amp; !buffering) {
<a class="jxr_linenumber" name="106" href="#106">106</a>             encoder.complete();
<a class="jxr_linenumber" name="107" href="#107">107</a>             <strong class="jxr_keyword">this</strong>.channel.close();
<a class="jxr_linenumber" name="108" href="#108">108</a>         }
<a class="jxr_linenumber" name="109" href="#109">109</a>     }
<a class="jxr_linenumber" name="110" href="#110">110</a> 
<a class="jxr_linenumber" name="111" href="#111">111</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> finish() {
<a class="jxr_linenumber" name="112" href="#112">112</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="113" href="#113">113</a>             <strong class="jxr_keyword">this</strong>.channel.close();
<a class="jxr_linenumber" name="114" href="#114">114</a>         } <strong class="jxr_keyword">catch</strong> (IOException ignore) {
<a class="jxr_linenumber" name="115" href="#115">115</a>         }
<a class="jxr_linenumber" name="116" href="#116">116</a>     }
<a class="jxr_linenumber" name="117" href="#117">117</a> 
<a class="jxr_linenumber" name="118" href="#118">118</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

